Subject: RE: QoS for BGP/MPLS VPNs in 2547bis

From: "Reddy, Vikram" <[email-masked]>
Date: Fri, 8 Mar 2002 08:43:14 -0500

Hi Eduard,

My requirement is to be able to apply QoS to an entire VPN and to
be able to do it automatically. No manual configuring should be 
done for each route.
We must also be able to reserve QoS dynamically when a the first route 
for the VPN is reserved and must be able to give all the routes learnt later
in the VPN the same QoS.

RT -> QoS mapping would be sufficient for a subset of routes.

In the first and second scenarios, of mapping DSCP or classifying, yes you
can do that
to the data traffic.
But when and where is the actual reservation for that traffic done on the
LSP Tunnel
if we want guaranteed end-end QoS. 
And then, how do you place this traffic on the LSP on which you have
reserved
QoS, because the VRF or classifier must be programmed with the LSP label and
then 
is a route accepted and traffic to the route is placed on that particular
LSP.

The third method said is not totally clear to me. Are you suggesting
that we use different virtual Ip addresses for the same PE router
and give different BGP Next hop based on the QoS.
Objections:
1) Unnecessary, extra information in the IGP.
2) Even if this is done, how does the ingress PE node know 
   next hop -> Qos mapping.
3) It is the sender who should decide on the QoS for the traffic (ingress
   PE in our case). 

Since 2547bis does not provide anything to uniquely identify a VPN 
and to identify traffic belonging to the VPN, there probably should
be an extension/draft yo include that.
VPN-VR does allow us to uniquely identify a VPN based on VPN-ID.
This will give us more control on the policies we want to apply to the
VPN.

Please comment.
Vikram.

-----Original Message-----
From: Metz, Eduard [mailto:[email-masked]]
Sent: Friday, March 08, 2002 4:04 AM
To: 'Reddy, Vikram'; [email-masked]; [email-masked]
Cc: [email-masked]'; [email-masked]'
Subject: RE: QoS for BGP/MPLS VPNs in 2547bis

Do you want to apply a specific QoS policy to an entire VPN, or to a set of
routes within that VPN (possibly with different QoS policy for different
routes)?

In general you could do the following wrt QoS and VPN (I assume DIFFSERV):
- map DSCP  (or EXP in case of carriers-carrier) of incoming traffic to MPLS
EXP field;
- classify and mark incoming traffic and then do above;
- create multiple TE tunnels between PE-s using different IP endpoints for
each PE, and set BGP NextHop to particular tunnel endpoint based on QoS
policy you want to apply (you can do this for an entire VPN or routes within
a VPN).

I think all these can be done today. I'm not sure if you could automate the
third option (which seems to be what you are after) by e.g. tagging routes
with a specific community based on which PE-s apply a QoS policy to the
traffic corresponding to that route. Also I'm not sure whether such would be
a local, implementation specific thing or something that should be described
in a draft/rfc.

Hope this helps.

cheers,
	Eduard

> -----Original Message-----
> From: Reddy, Vikram [mailto:[email-masked]]
> Sent: Friday, 08 March, 2002 12:02
> To: [email-masked]; [email-masked]
> Cc: [email-masked]'; [email-masked]'
> Subject: QoS for BGP/MPLS VPNs in 2547bis
> 
> 
> Hi,
> 
> In 2547bis there is no mechanism to specify the QoS parameters
> which we want to give for a VPN.
> 
> One possible way is to use the parameter VPN-ID and associate
> it with a set of QoS parameters.
> 
> But 2547bis does not specify a mechanism for distributing the VPN-ID.
> If we want to use the VPN-ID then we must depend on an 
> external mechanism to
> distribute the VPN-ID in the network.
> 
> But, even if we have an external mechanism to distribute the VPN-ID,
> if we want to associate a VPN with certain QoS and want the data 
> traffic for that VPN to receive that QOS, it would be possible only 
> if there is a VPN-ID attached with the route advertisement.
> 
> Similarly there could be other attributes (other than QoS parameters)
> which we may want to associate with a VPN and be able to use them on a
> per-VPN basis.
> 
> So what is the solution if I want to associate routes with 
> the VPNs they
> belong and give
> them the QoS (and other properties ) they are entitled to?
> 
> 
> It would be useful if BGP route advertisements also attach the VPN-ID 
> along with the prefix. We can configure each VRF with a VPN-ID and 
> attach it to all the route advertisements.
> 
> 
> When a service provider configures a VRF and associates it 
> with a VPN-ID
> he should also specify the QoS parameters which he wants to 
> give to the
> traffic
> flows of that VPN (If the VRFs import policies are configured 
> to receive
> routes
> from multiple VPNs,  he can specify the QoS for each VPN).
> 
> When a route is received from a remote PE and it matches with 
> the import
> RT of the VRF, an LSP must be found (or established/modified) 
> to accomodate
> the QoS
> parameters configured for the VPN-ID received in the advertisement 
> and the VRF entry made with that LSP tunnel label as the outer label.
> 
> An RT does not correspond with a VPN. Therefore the use of RT 
> for mapping 
> to QoS would not serve our purpose.
> 
> 
> Please comment.
> Vikram Reddy.
>

---

From: "Krzysztof Szarkowicz" <[email-masked]>
Date: Fri, 8 Mar 2002 15:09:13 +0100

Hi,

you could quite easily attach a community attribute to each prefix exported from VRF. You could than use this community as VPN ID. On the other side of your MPLS cloud you can than apply QoS based on this community value to all packtes that needs to be transported over MPLS cloud.

You don't need manual configuration for every prefix, just to prepare QoS templates at each PE.

Best regards,
Krzysztof Szarkowicz

---

From: Robert Raszuk <[email-masked]>
Date: Sat, 09 Mar 2002 15:09:58 +0100

Reddy,

> be able to do it automatically. No manual configuring should be

Per incomming interface EXP bit setting is possible at least in both
commercial MPLS-VPN implementations I am familiar with. 

> for the VPN is reserved and must be able to give all the routes learnt later

Giving QoS to the _routes_ is not a new concept. Why don't you use
regular qos policy propagation with bgp for all VPN routes or a subset
of those.

> be an extension/draft yo include that.

Appling different QoS per VPN is a pretty bad idea in itself. 

Now I am not sure if you are going to use LDP in the core or full mesh
of PE-PE traffic engineer tunnels. Both ways are possible to achive
decent diffserv with current 2547bis draft btw.

> This will give us more control on the policies we want to apply to the

Could you be a bit more specific how you are going to use this VPNID, in
particular how this VPN-ID will help you to identify the vpn data
belonging to this or different VPN for a selective qos treatment ?

R.